function myCallBack()
    //retrieve the handles called by their "Tag"
    // the first value: a
    h1=findobj("Tag","val1");
    // the second value: b
    h2=findobj("Tag","val2");
    // the result a+b
    h3=findobj("Tag","result");
    // compute the sum 
    val1=h1.String;  // value of a 
    val2=h2.String;  // value of b
    value=string(evstr(val1+'+'+val2))
    // assign the sum to the result box
    h3.string=value  
endfunction


function myGui()
// MAIN WINDOW  
hfig = figure(...
  'Tag', 'myGui', ...
  'BackgroundColor',  name2rgb("blue")/255, ...
  'Figure_name', 'myGui', ...
  'Position', [20 20 300 200]);

//1st TEXT FIELD  (a)
h1 = uicontrol(hfig, ...
  'Style', 'edit', ...
  'Tag', 'val1', ...
  'String', '1', ...
  'HorizontalAlignment', 'left', ...
  'FontAngle', 'italic', ...
  'FontSize', 20, ...
  'FontWeight', 'bold', ...
  'BackgroundColor', name2rgb("gray")/255, ...
  'ForegroundColor', name2rgb("black")/255, ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [50 100 50 20]);
  
// +
h4 = uicontrol(hfig, ...
  'Style', 'text', ...
  'Tag', 'plus', ...
  'String', '+', ...
  'HorizontalAlignment', 'center', ...
  'FontAngle', 'italic', ...
  'FontSize', 20, ...
  'FontWeight', 'bold', ...
  'BackgroundColor', name2rgb("gray")/255, ...
  'ForegroundColor', name2rgb("black")/255, ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [100 100 20 20]);

//2nd TEXT FIELD (b)
h2 = uicontrol(hfig, 'Style', 'edit', ...
  'Tag', 'val2', ...
  'String', '2', ...
  'HorizontalAlignment', 'left', ...
  'FontAngle', 'italic', ...
  'FontSize', 20, ...
  'FontWeight', 'bold', ...
  'BackgroundColor', name2rgb("gray")/255, ...
  'ForegroundColor', name2rgb("black")/255, ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [120 100 50 20]);

// '='
h5 = uicontrol(hfig, ...
  'Style', 'text', ...
  'Tag', 'equal', ...
  'String', '=', ...
  'HorizontalAlignment', 'center', ...
  'FontAngle', 'italic', ...
  'FontSize', 20, ...
  'FontWeight', 'bold', ...
  'BackgroundColor', name2rgb("gray")/255, ...
  'ForegroundColor', name2rgb("black")/255, ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [170 100 30 20]);

//3rd TEXT FIELD  (result a+b)
h3 = uicontrol(hfig, ...
  'Style', 'edit', ...
  'Tag', 'result', ...
  'String', '', ...
  'HorizontalAlignment', 'left', ...
  'FontAngle', 'italic', ...
  'FontSize', 20, ...
  'FontWeight', 'bold', ...
  'BackgroundColor', name2rgb("gray")/255, ...
  'ForegroundColor', name2rgb("red")/255, ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [200 100 50 20]);
 
  
// 'execute' BUTTON
buttonexec = uicontrol(hfig, ...
  'Style', 'pushbutton', ...
  'Tag', 'button1', ...
  'String', 'compute', ...
  'Callback','myCallBack()', ... // call the sum computation
  'BackgroundColor', name2rgb("green")/255, ...
  'ForegroundColor', name2rgb("black")/255, ...
  'FontAngle', 'normal', ...
  'FontSize', 20, ...
  'FontWeight', 'normal', ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [50 50 100 20]);
  
  // 'close' BUTTON
buttonclose = uicontrol(hfig, ...
  'Style', 'pushbutton', ...
  'Tag', 'button2', ...
  'String', 'close', ...
  'Callback','delete(findobj('"Tag'",'"myGui'"))', ... // delete the window 
  'BackgroundColor', name2rgb("green")/255, ...
  'ForegroundColor', name2rgb("black")/255, ...
  'FontAngle', 'normal', ...
  'FontSize', 20, ...
  'FontWeight', 'normal', ...
  'FontUnits', 'pixels', ...
  'FontName', 'helvetica', ...
  'Position', [160 50 100 20]);

endfunction 

myGui()
